----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 		befro
-- 
-- Create Date:    09:57:55 03/16/2009 
-- Design Name: 
-- Module Name:    PollinSerial - Behavioral 
-- Project Name: 
-- Target Devices: pollin cpld board
-- Tool versions: 
-- Description: 	test of serial comminication port on pollin board,
--					   write increasing counter values to serial port
--						37% register sources of the xc95144 used
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity chPollinSerial is
    Port ( clkIn : in  STD_LOGIC;
           serOut : out  STD_LOGIC;
           ledsOut : out  STD_LOGIC_VECTOR (7 downto 0));
end chPollinSerial;

architecture Behavioral of chPollinSerial is
	signal counter: STD_LOGIC_VECTOR ( 28 downto 0 );
	signal shiftRegister: STD_LOGIC_VECTOR ( 10 downto 0 );
	signal shiftClk: STD_LOGIC ;
	signal state: STD_LOGIC_VECTOR ( 3 downto 0 );
	signal clkDivider: STD_LOGIC_VECTOR ( 10 downto 0 );
	signal data: STD_LOGIC_VECTOR (7 downto 0 );
begin

	serialClkDivider: process (clkIn)
	begin
			if RISING_EDGE(clkIn) then
				if(clkDivider =  "11010000011") then -- divider = 1667 == 9600Baud@16MHz
					clkDivider <= "00000000000";
					shiftClk <= '1';
				else
					clkDivider <= clkDivider + 1;
					shiftClk <= '0';
				end if;
			end if;
	end process serialClkDivider;
	
	divider: process (clkIn)
	begin
		if RISING_EDGE(clkIn) then 
			counter <= counter+1;
		end if ;
	end process divider ;
	
	shifter: process ( shiftClk )
	begin
		if RISING_EDGE (shiftClk) then
			case state is
				when "0000" => shiftRegister <= '1' & data & "01"; -- stop bit + daten + startbit
				when others => shiftRegister <= '1' & shiftRegister(10 downto 1); -- daten rausschieben
			end case;
		end if;
	end process shifter;

	state <= counter(20 downto 17);
	data <= counter(28 downto 21 );
	
	ledsOut <= data;
	serOut <= shiftRegister(0);
end Behavioral;

